Index: trunk/MagicSoft/Mars/mjobs/MJCut.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCut.cc	(revision 6992)
+++ trunk/MagicSoft/Mars/mjobs/MJCut.cc	(revision 6993)
@@ -258,5 +258,5 @@
 
     // Save also the result, not only the setup
-    const MHAlpha *halpha = (MHAlpha*)plist.FindObject(fNameHist, "MHAlpha");
+    const MHAlpha *halpha = (MHAlpha*)plist.FindObject("Hist", "MHAlpha");
     if (halpha)
         arr.Add((TObject*)(&halpha->GetAlphaFitter()));
@@ -365,5 +365,5 @@
     }
 
-    const TString objname(Form("%s%s", fNameHist.Data(), name));
+    const TString objname(Form("%s%s", "Hist"/*fNameHist.Data()*/, name));
     MHAlpha *h = (MHAlpha*)plist.FindCreateObj(fNameHist, objname);
     if (!h)
@@ -446,5 +446,5 @@
 
     MHAlpha *halphaoff = CreateNewHist(plist, "Off");
-    MFillH falpha(halphaoff, "MHillasSrc", "FillAlpha");
+    MFillH falpha(halphaoff, "", "FillHist");
     MFillH ffs("MHFalseSourceOff [MHFalseSource]", "MHillas", "FillFS");
 
@@ -675,5 +675,5 @@
     */
     MHAlpha *halphaon=CreateNewHist(plist);
-    MFillH falpha2(halphaon, "MHillasSrc", "FillAlpha");
+    MFillH falpha2(halphaon, "", "FillHist");
     MFillH ffs2("MHFalseSource", "MHillas", "FillFS");
 
Index: trunk/MagicSoft/Mars/mjobs/MJSpectrum.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJSpectrum.cc	(revision 6992)
+++ trunk/MagicSoft/Mars/mjobs/MJSpectrum.cc	(revision 6993)
@@ -66,4 +66,5 @@
 // Tasks/Filter
 #include "MReadMarsFile.h"
+#include "MReadMarsFile.h"
 #include "MFEventSelector2.h"
 #include "MFDataMember.h"
@@ -173,5 +174,5 @@
 
     TH1D *vstime = (TH1D*)arr.FindObjectInCanvas("Theta",  "TH1D", "OnTime");
-    TH1D *size   = (TH1D*)arr.FindObjectInCanvas("Excess", "TH1D", "MHAlpha");
+    TH1D *size   = (TH1D*)arr.FindObjectInCanvas("Excess", "TH1D", "Hist");
     if (!vstime || !size)
         return -1;
@@ -183,5 +184,5 @@
 
     if (fDisplay)
-        arr.DisplayIn(*fDisplay, "MHAlpha");
+        arr.DisplayIn(*fDisplay, "Hist");
 
     if (!ReadTask(fCut0, "Cut0"))
@@ -343,6 +344,6 @@
     taskenv1.SetDefault(fEstimateEnergy ? fEstimateEnergy : &est);
 
-    MFillH fill1("MHAlphaOff [MHAlpha]", "MHillasSrc", "FillAlphaOff");
-    MFillH fill2("MHAlphaOn  [MHAlpha]", "MHillasSrc", "FillAlphaOn");
+    MFillH fill1("HistOff [MHAlpha]", "MHillasSrc", "FillHistOff");
+    MFillH fill2("HistOn  [MHAlpha]", "MHillasSrc", "FillHistOn");
 
     MFDataMember f0("DataType.fVal", '<', 0.5, "FilterOffData");
@@ -381,8 +382,8 @@
     }
 
-    const MHAlpha *halpha = (MHAlpha *)plist.FindObject("MHAlphaOn");
+    const MHAlpha *halpha = (MHAlpha *)plist.FindObject("HistOn");
     if (!halpha)
     {
-        *fLog << err << GetDescriptor() << ": MHAlphaOn [MHAlpha] not found... abort." << endl;
+        *fLog << err << GetDescriptor() << ": HistOn [MHAlpha] not found... abort." << endl;
         return kFALSE;
     }
@@ -615,5 +616,5 @@
     cout << "Searching..." << endl;
 
-    TH1 *excess = (TH1D*)arr.FindObjectInCanvas("Excess", "TH1D", "MHAlpha");
+    TH1 *excess = (TH1D*)arr.FindObjectInCanvas("Excess", "TH1D", "Hist");
     if (!excess)
         return kFALSE;
Index: trunk/MagicSoft/Mars/mjobs/MJStar.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJStar.cc	(revision 6992)
+++ trunk/MagicSoft/Mars/mjobs/MJStar.cc	(revision 6993)
@@ -62,10 +62,10 @@
 #include "MSrcPosCalc.h"
 #include "MHillasCalc.h"
-#include "../mmuon/MMuonSearchParCalc.h"
-#include "../mmuon/MMuonCalibParCalc.h"
-#include "../mmuon/MMuonSetup.h"
+#include "MMuonSearchParCalc.h"
+#include "MMuonCalibParCalc.h"
 #include "MFillH.h"
 #include "MWriteRootFile.h"
 
+#include "MMuonSetup.h"
 #include "MObservatory.h"
 #include "MPointingPosCalc.h"
@@ -81,8 +81,14 @@
 // Sets fRuns to 0, fExtractor to NULL, fDataCheck to kFALSE
 //
-MJStar::MJStar(const char *name, const char *title) 
+MJStar::MJStar(const char *name, const char *title) : fMuonAnalysis(kTRUE)
 {
     fName  = name  ? name  : "MJStar";
     fTitle = title ? title : "Standard analysis and reconstruction";
+}
+
+Bool_t MJStar::CheckEnvLocal()
+{
+    DisableMuonAnalysis(!GetEnv("MuonAnalysis", fMuonAnalysis));
+    return kTRUE;
 }
 
@@ -357,17 +363,10 @@
     tlist2.AddToList(&fill5);
 
-    // *********************************************************
-    MMuonSetup setup;
-    plist.AddToList(&setup);
-
+    // ----------------------- Muon Analysis ----------------------
     MF fmuon1("MHillas.fSize>150", "MuonPreCut");
-
-    MF fmuon2("(MMuonSearchPar.fRadius>180) &&"
-              "(MMuonSearchPar.fRadius<400) &&"
+    MF fmuon2("(MMuonSearchPar.fRadius>180) && (MMuonSearchPar.fRadius<400) &&"
               "(MMuonSearchPar.fDeviation<45)", "MuonSearchCut");
-    fmuon2.SetFilter(&fmuon1);
-
-    MF fmuon3("(MMuonCalibPar.fArcPhi>175)  &&"
-              "(MMuonSearchPar.fDeviation<37)", "MuonFinalCut");
+    MF fmuon3("(MMuonCalibPar.fArcPhi>175)  && (MMuonSearchPar.fDeviation<37)",
+              "MuonFinalCut");
 
     MMuonSearchParCalc muscalc;
@@ -377,18 +376,20 @@
     mcalc.SetFilter(&fmuon2);
 
-    MFillH fill11("MHSingleMuon", "", "FillMuon");
-    MFillH fill10("MHMuonPar",    "", "FillMuonPar");
-    fill11.SetFilter(&fmuon2);
-    fill10.SetFilter(&fmuon3);
-
-    tlist2.AddToList(&fmuon1);
-    tlist2.AddToList(&muscalc);
-    tlist2.AddToList(&fmuon2);
-    tlist2.AddToList(&fill11);
-    tlist2.AddToList(&mcalc);
-    tlist2.AddToList(&fmuon3);
-    tlist2.AddToList(&fill10);
-
-    // *********************************************************
+    MFillH fillmuon("MHSingleMuon", "", "FillMuon");
+    MFillH fillmpar("MHMuonPar",    "", "FillMuonPar");
+    fillmuon.SetFilter(&fmuon2);
+    fillmpar.SetFilter(&fmuon3);
+
+    if (fMuonAnalysis)
+    {
+        tlist2.AddToList(&fmuon1);
+        tlist2.AddToList(&muscalc);
+        tlist2.AddToList(&fmuon2);
+        tlist2.AddToList(&fillmuon);
+        tlist2.AddToList(&mcalc);
+        tlist2.AddToList(&fmuon3);
+        tlist2.AddToList(&fillmpar);
+    }
+    // ------------------------------------------------------------
 
     //tlist2.AddToList(&fill6);
Index: trunk/MagicSoft/Mars/mjobs/MJStar.h
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJStar.h	(revision 6992)
+++ trunk/MagicSoft/Mars/mjobs/MJStar.h	(revision 6993)
@@ -9,9 +9,16 @@
 {
 private:
+    Bool_t fMuonAnalysis;
+
     Bool_t WriteResult();
+    Bool_t CheckEnvLocal();
 
 public:
     MJStar(const char *name=NULL, const char *title=NULL);
 
+    // Setup
+    void DisableMuonAnalysis(Bool_t b=kTRUE) { fMuonAnalysis = !b; }
+
+    // Process
     Bool_t Process(Bool_t ismc=kFALSE);
 
Index: trunk/MagicSoft/Mars/mjobs/Makefile
===================================================================
--- trunk/MagicSoft/Mars/mjobs/Makefile	(revision 6992)
+++ trunk/MagicSoft/Mars/mjobs/Makefile	(revision 6993)
@@ -23,5 +23,5 @@
            -I../mbadpixels -I../msignal -I../mraw -I../mpedestal -I../mtools \
            -I../mimage -I../mpointing -I../mastro -I../mfbase -I../mhvstime \
-           -I../mtrigger
+           -I../mtrigger -I../mmuon
 
 SRCFILES = MSequence.cc \