Index: trunk/MagicSoft/Mars/mjobs/MJCut.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCut.cc	(revision 6998)
+++ trunk/MagicSoft/Mars/mjobs/MJCut.cc	(revision 7001)
@@ -78,5 +78,5 @@
     : fStoreSummary(kFALSE), fStoreResult(kTRUE), fWriteOnly(kFALSE),
     fIsWobble(kFALSE), fIsMonteCarlo(kFALSE),  fFullDisplay(kFALSE),
-    fNameHist("MHTheta"), fCalcHadronness(0)
+    fNameHist("MHThetaSq"), fCalcHadronness(0)
 {
     fName  = name  ? name  : "MJCut";
@@ -428,4 +428,6 @@
     MBinning bins7("BinningDist");
     MBinning bins8("BinningMaxDist");
+    MBinning bins9("BinningM3Long");
+    MBinning bins0("BinningConc1");
     plist.AddToList(&bins1);
     plist.AddToList(&bins2);
@@ -436,4 +438,6 @@
     plist.AddToList(&bins7);
     plist.AddToList(&bins8);
+    plist.AddToList(&bins9);
+    plist.AddToList(&bins0);
 
     // --------------------------------------------------------------------------------
Index: trunk/MagicSoft/Mars/mjobs/MJOptimize.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJOptimize.cc	(revision 6998)
+++ trunk/MagicSoft/Mars/mjobs/MJOptimize.cc	(revision 7001)
@@ -181,4 +181,5 @@
     eval->SetVal(0);
 
+    const Bool_t isnull = gLog.IsNullOutput();
     if (fDebug<3)
         gLog.SetNullOutput(kTRUE);
@@ -190,5 +191,5 @@
 
     if (fDebug<3)
-        gLog.SetNullOutput(kFALSE);
+        gLog.SetNullOutput(isnull);
 
     const Double_t f = eval->GetVal();
Index: trunk/MagicSoft/Mars/mjobs/MJSpectrum.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJSpectrum.cc	(revision 6998)
+++ trunk/MagicSoft/Mars/mjobs/MJSpectrum.cc	(revision 7001)
@@ -178,4 +178,10 @@
         return -1;
 
+    TObject *hist = arr.FindObjectInCanvas("Hist", "MHAlpha", "Hist");
+    cout << "HIST: " << hist << endl;
+    if (hist)
+        cout << "TYPE: " << hist->ClassName() << endl;
+    arr.Print();
+
     vstime->Copy(h1);
     size->Copy(h2);
@@ -344,6 +350,6 @@
     taskenv1.SetDefault(fEstimateEnergy ? fEstimateEnergy : &est);
 
-    MFillH fill1("HistOff [MHAlpha]", "MHillasSrc", "FillHistOff");
-    MFillH fill2("HistOn  [MHAlpha]", "MHillasSrc", "FillHistOn");
+    MFillH fill1("HistEOff [MHAlpha]", "MHillasSrc", "FillHistEOff");
+    MFillH fill2("HistE    [MHAlpha]", "MHillasSrc", "FillHistE");
 
     MFDataMember f0("DataType.fVal", '<', 0.5, "FilterOffData");
@@ -382,8 +388,8 @@
     }
 
-    const MHAlpha *halpha = (MHAlpha *)plist.FindObject("HistOn");
+    const MHAlpha *halpha = (MHAlpha *)plist.FindObject("HistE");
     if (!halpha)
     {
-        *fLog << err << GetDescriptor() << ": HistOn [MHAlpha] not found... abort." << endl;
+        *fLog << err << GetDescriptor() << ": HistE [MHAlpha] not found... abort." << endl;
         return kFALSE;
     }
@@ -597,5 +603,4 @@
     *fLog << inf << "Reading from file: " << fPathIn << endl;
 
-    cout << "Opening..." << endl;
     TFile file(fPathIn, "READ");
     if (!file.IsOpen())
@@ -605,5 +610,4 @@
     }
 
-    cout << "Reading..." << endl;
     file.cd();
     MStatusArray arr;
@@ -614,11 +618,7 @@
     }
 
-    cout << "Searching..." << endl;
-
     TH1 *excess = (TH1D*)arr.FindObjectInCanvas("Excess", "TH1D", "Hist");
     if (!excess)
         return kFALSE;
-
-    cout << "Displaying..." << endl;
 
     // ------------------- Plot excess versus size ------------------- 
@@ -638,6 +638,4 @@
     // Don't do this on the original object!
     excess->SetStats(kFALSE);
-
-    cout << "ExcessSize..." << endl;
 
     TObject *o=0;
@@ -656,26 +654,16 @@
     }
 
-    cout << "Dist..." << endl;
-
     // -------------- Comparison of Image Parameters --------------
     c.cd(2);
     PlotSame(arr, plist, "Dist",   "HilSrc",  "MHHilSrcMCPost");
 
-    cout << "Length..." << endl;
-
     c.cd(3);
     PlotSame(arr, plist, "Length", "PostCut", "MHHillasMCPost");
 
-    cout << "M3l..." << endl;
-
     c.cd(4);
     PlotSame(arr, plist, "M3l",    "HilExt",  "MHHilExtMCPost");
 
-    cout << "Conc1..." << endl;
-
     c.cd(5);
     PlotSame(arr, plist, "Conc1",  "NewPar",  "MHNewParMCPost");
-
-    cout << "Width..." << endl;
 
     c.cd(6);
@@ -710,4 +698,6 @@
     MBinning bins7("BinningDist");
     MBinning bins8("BinningMaxDist");
+    MBinning bins9("BinningM3Long");
+    MBinning bins0("BinningConc1");
 
     MAlphaFitter fit;
@@ -722,4 +712,6 @@
     plist.AddToList(&bins7);
     plist.AddToList(&bins8);
+    plist.AddToList(&bins9);
+    plist.AddToList(&bins0);
     plist.AddToList(&fit);
 