Index: trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc	(revision 7023)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibrateSignal.cc	(revision 7028)
@@ -307,4 +307,6 @@
     MHCalibrationChargePINDiode hpndiod;
     MHCalibrationRelTimeCam     hrelcam;
+    MHCalibrationHiLoCam        hilocam;
+    MHCalibrationPulseTimeCam   hpulcam;
 
     hchacam.SetOscillations(kFALSE);
@@ -576,6 +578,6 @@
     MFillH filcam(&hchacam, "MExtractedSignalCam",        "FillChargeCam");
     MFillH filtme(&hrelcam, "MArrivalTimeCam",            "FillRelTime");
-    MFillH filhil("MHCalibrationHiLoCam",        "MExtractedSignalCam",        "FillHiLoRatio");
-    MFillH filpul("MHCalibrationPulseTimeCam",   "MRawEvtData",                "FillPulseTime");
+    MFillH filhil(&hilocam, "MExtractedSignalCam",        "FillHiLoRatio");
+    MFillH filpul(&hpulcam, "MRawEvtData",                "FillPulseTime");
     filpin.SetBit(MFillH::kDoNotDisplay);
     filbnd.SetBit(MFillH::kDoNotDisplay);
@@ -735,5 +737,16 @@
       tlist2.AddToList(&filhil);
     if (fIsPulsePosCheck)
-      tlist2.AddToList(&filpul);
+        tlist2.AddToList(&filpul);
+    if (fIsHiLoCalibration)
+    {
+        plist.AddToList(&hilocam);
+        tlist2.AddToList(&filhil);
+    }
+    if (fIsPulsePosCheck)
+    {
+        plist.AddToList(&hpulcam);
+        tlist2.AddToList(&filpul);
+    }
+
     tlist2.AddToList(&fill2);
     tlist2.AddToList(&calib);
Index: trunk/MagicSoft/Mars/mjobs/MJCalibration.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 7023)
+++ trunk/MagicSoft/Mars/mjobs/MJCalibration.cc	(revision 7028)
@@ -842,7 +842,7 @@
       // for the datacheck, fix the ranges!!
       //
-      const Double_t max = 11.;
+      const Double_t max = 12.;
       obj8->SetMinimum(0.);
-      obj8->SetMaximum(11.);
+      obj8->SetMaximum(max);
       //
       // Set the datacheck sizes:
@@ -857,49 +857,53 @@
       pave->SetBit(kCanDelete);
       pave->ConvertNDCtoPad();
-      pave->SetTextSize(0.05);
+      pave->SetTextSize(0.045);
       pave->AddText("  ");
-      TText *t1 = pave->AddText(Form("Signal smaller 4.5 Pedestal RMS:                 %3i pixels",
+      TText *t1 = pave->AddText(Form("Signal smaller 4.5 Pedestal RMS:               %3i pixels",
                                        CountBadPixels(&disp24,1)));
-      t1->SetTextColor(gStyle->GetColorPalette(Int_t(1./max*numcol + 1.)));
+      t1->SetTextColor(gStyle->GetColorPalette(Int_t(1./max*numcol)));
       t1->SetTextAlign(12);
-      TText *t2 = pave->AddText(Form("%s%3i%s","Signal Rel. error too large:                            ",
+      TText *t2 = pave->AddText(Form("%s%3i%s","Signal Rel. error too large:                          ",
                                        CountBadPixels(&disp24,2)," pixels"));
-      t2->SetTextColor(gStyle->GetColorPalette(Int_t(2./max*numcol + 1.)));
+      t2->SetTextColor(gStyle->GetColorPalette(Int_t(2./max*numcol)));
       t2->SetTextAlign(12);
-      TText *t4 = pave->AddText(Form("Low Gain Saturation:                                     %3i pixels",
+      TText *t4 = pave->AddText(Form("Low Gain Saturation:                                   %3i pixels",
                                        CountBadPixels(&disp24,3)));
-      t4->SetTextColor(gStyle->GetColorPalette(Int_t(3./max*numcol + 1.)));
+      t4->SetTextColor(gStyle->GetColorPalette(Int_t(3./max*numcol)));
       t4->SetTextAlign(12);
-      TText *t5 = pave->AddText(Form("Mean Arr. Time In First Extraction Bin:        %3i pixels",
+      TText *t5 = pave->AddText(Form("Mean Arr. Time In First Extraction Bin:      %3i pixels",
                                        CountBadPixels(&disp24,4)));
-      t5->SetTextColor(gStyle->GetColorPalette(Int_t(4./max*numcol + 1.)));
+      t5->SetTextColor(gStyle->GetColorPalette(Int_t(4./max*numcol)));
       t5->SetTextAlign(12);
-      TText *t6 = pave->AddText(Form("Mean Arr. Time In Last 2 Extraction Bins:   %3i pixels",
+      TText *t6 = pave->AddText(Form("Mean Arr. Time In Last 2 Extraction Bins:  %3i pixels",
                                        CountBadPixels(&disp24,5)));
-      t6->SetTextColor(gStyle->GetColorPalette(Int_t(5./max*numcol + 1.)));
+      t6->SetTextColor(gStyle->GetColorPalette(Int_t(5./max*numcol)));
       t6->SetTextAlign(12);
-      TText *t9 = pave->AddText(Form("Deviating Number of Photons:                      %3i pixels",
+      TText *t9 = pave->AddText(Form("Deviating Number of Photons:                    %3i pixels",
                                        CountBadPixels(&disp24,6)));
-      t9->SetTextColor(gStyle->GetColorPalette(Int_t(6./max*numcol + 1.)));
+      t9->SetTextColor(gStyle->GetColorPalette(Int_t(6./max*numcol)));
       t9->SetTextAlign(12);
-      TText *t10= pave->AddText(Form("High-Gain Histogram Overflow:                    %3i pixels",
+      TText *t10= pave->AddText(Form("High-Gain Histogram Overflow:                  %3i pixels",
                                        CountBadPixels(&disp24,7 )));
-      t10->SetTextColor(gStyle->GetColorPalette(Int_t(7./max*numcol + 1.)));
+      t10->SetTextColor(gStyle->GetColorPalette(Int_t(7./max*numcol)));
       t10->SetTextAlign(12);
-      TText *t11= pave->AddText(Form("Low-Gain Histogram Overflow:                     %3i pixels",
+      TText *t11= pave->AddText(Form("Low-Gain Histogram Overflow:                   %3i pixels",
                                        CountBadPixels(&disp24,8 )));
-      t11->SetTextColor(gStyle->GetColorPalette(Int_t(8./max*numcol + 1.)));
+      t11->SetTextColor(gStyle->GetColorPalette(Int_t(8./max*numcol)));
       t11->SetTextAlign(12);
-      TText *t12= pave->AddText(Form("Presumably dead from Ped. Rms:                %3i pixels",
+      TText *t12= pave->AddText(Form("Presumably dead from Ped. Rms:              %3i pixels",
                                        CountBadPixels(&disp24,9 )));
-      t12->SetTextColor(gStyle->GetColorPalette(Int_t(9./max*numcol + 1.)));
+      t12->SetTextColor(gStyle->GetColorPalette(Int_t(9./max*numcol)));
       t12->SetTextAlign(12);
-      TText *t13= pave->AddText(Form("Fluctuating Pulse Arrival Times:                   %3i pixels",
+      TText *t13= pave->AddText(Form("Fluctuating Pulse Arrival Times:                 %3i pixels",
                                        CountBadPixels(&disp24,10)));
-      t13->SetTextColor(gStyle->GetColorPalette(Int_t(10./max*numcol + 1.)));
+      t13->SetTextColor(gStyle->GetColorPalette(Int_t(10./max*numcol)));
       t13->SetTextAlign(12);
-      TText *t14= pave->AddText(Form("Previously Excluded:                                     %3i pixels",
+      TText *t17 = pave->AddText(Form("Deviating Number of Photo-electrons:       %3i pixels",
                                        CountBadPixels(&disp24,11)));
-      t14->SetTextColor(gStyle->GetColorPalette(Int_t(11./max*numcol + 1.)));
+      t17->SetTextColor(gStyle->GetColorPalette(Int_t(11./max*numcol)));
+      t17->SetTextAlign(12);
+      TText *t14= pave->AddText(Form("Previously Excluded:                                   %3i pixels",
+                                       CountBadPixels(&disp24,12)));
+      t14->SetTextColor(gStyle->GetColorPalette(Int_t(12./max*numcol)));
       t14->SetTextAlign(12);
       pave->Draw();
Index: trunk/MagicSoft/Mars/mjobs/MJPedestal.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJPedestal.cc	(revision 7023)
+++ trunk/MagicSoft/Mars/mjobs/MJPedestal.cc	(revision 7028)
@@ -983,5 +983,13 @@
       {
         if (fExtractor->InheritsFrom("MExtractTimeAndCharge"))
-          hpedcam.SetFitStart(-10.*((MExtractTimeAndCharge*)fExtractor)->GetWindowSizeHiGain());
+          {
+              if (fExtractionType!=kFundamental)
+              {
+                  const MExtractTimeAndCharge &e = *static_cast<MExtractTimeAndCharge*>(fExtractor);
+                  hpedcam.SetFitStart(-5*e->GetWindowSizeHiGain());
+              }
+              else
+                  hpedcam.SetFitStart(10.);
+          }
         
         pedcalc.SetIntermediateStorage();