Index: trunk/MagicSoft/Mars/mtemp/mpisa/Changelog_pisa
===================================================================
--- trunk/MagicSoft/Mars/mtemp/mpisa/Changelog_pisa	(revision 5138)
+++ 	(revision )
@@ -1,130 +1,0 @@
-Please  do  not write behind the end of line tag so that it is  possible
-to   send  a   Changelog   file  to  a  line  printer  directly.  Thanks.
-
-For your entries please follow this style:
-
-_yyyy/mm/dd:_[Your Name]
-_
-___*_filename:
-_____-_description
-_
-___*_filename2, filename3:
-_____-_description
-_
-_
-_
-
-While an underscore is a placeholder for a white-space or an empty line.
-
-                                                 -*-*- END OF LINE -*-*-
-
- 2004/09/23: Nicola Galante
-
-   * mpisa/classes/mispointing
-     - Aggiunte le seguenti classi:MFindStars.cc          MStarLocalCam.cc      MVPPlotter.cc
-                                   MFindStars.h           MStarLocalCam.h       MVPPlotter.h
-                                   MHTelAxisFromStars.cc  MStarLocalPos.cc      MVPTime.cc
-                                   MHTelAxisFromStars.h   MStarLocalPos.h       MVPTime.h
-                                   MSkyCamTrans.cc        MTelAxisFromStars.cc
-                                   MSkyCamTrans.h         MTelAxisFromStars.h 
-                                   MSourceDirections.cc   MVPObject.cc
-                                   MSourceDirections.h    MVPObject.h
-       Le seguenti modifiche sono state effettuate: 
-       1) the names 
-	of the branches inside classes MSourceDirections.cc and MFindStars.cc were 
-	defined without the final dot (i.e. "MMcConfigRunHeader" instead of 
-	"MMcConfigRunHeader.", for example), so that the Get...() methods returned 
-	null pointers.
-
-       2) First of all I realized that the Process of MTelAxisFromStars was skipped 
-	because no stars were found in the MStarCam *fStarCam container. After 
-	several attempts I found that the problem was solved by changing
-
-	tlist.AddToList(&findstars, "Currents");
-
-	with
-
-	tlist.AddToList(&findstars);
-
-	3) I inform you also that I use two MReadReport objects, one 
-	for the DC currents and one for the Drive reports file, and then 
-	add the two MReadReport objects to the tasklist, because I had some 
-	problems in making ROOT accepting to read different trees in different 
-	files added to the same object, as done in the original macro (this could 
-	be related to the problem I encoured in adding the MFindStar to the 
-	tasklist).
-
-
-     - aggiunta la macro macros/findTelAxisFromStars.C
-
-
- 2004/09/13: Antonio Stamerra
-
-   * mpisa/macros/readIPR.C
-     - macro to read IPRs
-
-
- 2004/05/24: Antonio Stamerra
-
-   * mpisa/classes/mtrigger/*, mpisa/classes/MTriggerReport.[h,cc]
-     - classes almost completed; compiles.  
-	
-
- 2004/05/24: Antonio Stamerra
-
-   * mpisa/classes/MTriggerLiveTime.[h.cc]
-     - added new class container for the Live-Deadtime from report files (.rep)
-	
-   * mpisa/classes/mtrigger
-     - added new directory for the MTrigger* classes. These
-	classes have been moved there. 
-     - Various modifications have been made on these classes.
-	The MReportTrigger now fills these containers.
-
- 2004/05/24: Antonio Stamerra
-
-   * mpisa/classes/MTriggerCell.[h.cc]
-     - added new class container for the cell rates from report files (.rep)
-
-   * mpisa/classes/MTriggerBit.[h.cc]
-     - added new class container for the L2 bits rates from report files (.rep)
-
-   * mpisa/classes/MTriggerPrescFact.[h.cc]
-     - added new class container for the prescaling factors from 
-	report files (.rep)
-
-   * mpisa/classes/MTriggerReport.[h.cc]
-     - added copy of the mreport/MReportTrigger class to modify to new
-	report file format and to use the trigger class containers
-
-
- 2004/05/21: Antonio Stamerra
-
-   * mpisa/classes
-     - added directory /classes. Should be used to add new classes
-
-   * mpisa/Makefile, mpisa/PisaLinkDef.h, mpisa/PisaIncl.h
-     - added to compile internally to the mpisa directory the classes
-
-   * mpisa/classes/MTriggerIPR.[h,cc]
-     - added container for IPR values.
-   
-
- 2004/05/12: Antonio Stamerra
-
-   * mpisa/macros
-     - added macros:
-	- first_ana.C   given a file with hillas analysis produces ON-OFF plots
-	- production.C  produces calibrated data (photons) from raw data
-	- HillasAnal.C  makes standard Hillas analysis
-
-   * mpisa/macros
-     - added this directory 	
-
-   * added this file Changelog_pisa
-     - test	
-
- 2004/05/11: Antonio Stamerra
-
-   * mtemp/mpisa
-     - 	added directory mpisa in mtemp
Index: trunk/MagicSoft/Mars/mtemp/mpisa/Makefile
===================================================================
--- trunk/MagicSoft/Mars/mtemp/mpisa/Makefile	(revision 5138)
+++ 	(revision )
@@ -1,53 +1,0 @@
-##################################################################
-#
-#   subdirectory makefile
-# 
-#   for the MARS software
-#
-##################################################################
-include ../../Makefile.conf.$(OSTYPE)
-include ../../Makefile.conf.general
-
-#------------------------------------------------------------------------------
-
-CINT     = Pisa
-
-#------------------------------------------------------------------------------
-
-INCLUDES = -I. \
-	   -I../../mbase \
-	   -I../../mjobs \
-	   -I../../mpedestal \
-	   -I../../mbadpixels \
-	   -I../../mfileio \
-           -I../../mraw \
-           -I../../manalysis \
-	   -I../../mgui \
-	   -I../../mgeom \
-	   -I../../msignal \
-	   -I../../mcalib \
-	   -I../../mfilter \
-	   -I../../mhbase \
-	   -I../../mimage \
-	   -I../../mpointing \
-	   -I../../mcamera \
-	   -I../../mhist \
-	   -I../../mmc \
-	   -I../../mreport \
-	   -I../../mastro
-
-SRCFILES = \
-        ./classes/MTriggerIPR.cc \
-        ./classes/MTriggerCell.cc \
-        ./classes/MTriggerBit.cc \
-        ./classes/MTriggerPrescFact.cc \
-        ./classes/MTriggerLiveTime.cc
-
-############################################################
-
-all: $(OBJS)
-
-include ../../Makefile.rules
-
-clean:	rmcint rmobjs rmcore rmlib
-mrproper:	clean rmbak
Index: trunk/MagicSoft/Mars/mtemp/mpisa/PisaIncl.h
===================================================================
--- trunk/MagicSoft/Mars/mtemp/mpisa/PisaIncl.h	(revision 5138)
+++ 	(revision )
@@ -1,3 +1,0 @@
-#ifndef __CINT__
-
-#endif // __CINT__
Index: trunk/MagicSoft/Mars/mtemp/mpisa/PisaLinkDef.h
===================================================================
--- trunk/MagicSoft/Mars/mtemp/mpisa/PisaLinkDef.h	(revision 5138)
+++ 	(revision )
@@ -1,13 +1,0 @@
-#ifdef __CINT__
-
-#pragma link off all globals;
-#pragma link off all classes;
-#pragma link off all functions;
-
-#pragma link C++ class MTriggerIPR+;
-#pragma link C++ class MTriggerCell+;
-#pragma link C++ class MTriggerBit+;
-#pragma link C++ class MTriggerPrescFact+;
-#pragma link C++ class MTriggerLiveTime+;
-
-#endif