Index: trunk/MagicSoft/Mars/NEWS
===================================================================
--- trunk/MagicSoft/Mars/NEWS	(revision 7035)
+++ trunk/MagicSoft/Mars/NEWS	(revision 7047)
@@ -2,56 +2,30 @@
  *** Version <cvs>
 
-   - added muon support to star. A new tab "MHMuonPar" is displayed.
-     The lower right plot is an estimate of the point spread
-     function. A reference value is displayed. To get the real PSF
-     you must compare with MC. The setup for the muon analysis
-     is done in star.rc. More informations can be found in
-     MHSingleMuon and MHCalibParCalc
-
-   - added a full featured spectrum program (sponde) which reads
-     ganymed output and monte carlos and compiles a spectrum
-
-   - added new histograms for image parameters versus size (MHVsSize)
-
-   - support for cc file versions newer than V200504130. Added
+   - general: Changed the default paths for calibrated data and image
+     files. (The implemented access to these files doesn't yet exist)
+
+   - general: support for MRunIter has been removed from the job classes
+     (use the setter functions of MSeqeunce instead)
+
+   - general: ProcessFile has been renamed to Process in all job classes,
+     because ProcessFile is missleading
+
+   - general: The storage of the palette in MHCamera is now possible
+
+   - general: new bits describing unsuitable and unreliable pixels have
+     been introduced in MBadPixelsPix: kPreviouslyExcluded, 
+     kDeadPedestalRms, kFluctuatingArrivalTimes
+
+   - general: fixed reading of CC-REPORTS (weather data) for Arehucas file
+     versions newer than V200404070 
+
+   - general: support for cc file versions newer than V200504130. Added
      support for active loads (MCameraActiveLoad) and central pixel
      (MCameraCentralPixel)
 
-   - fixed a bug in the recognition of the calibration bit pattern. 
-     Concerns only intensity calibration. (The strength of the 
-     intensity has been updated in some cases)
-
-   - add a filter against PIN Diode events when running over calibration
-     runs since some of the recent calibration runs have been taken 
-     with Pin Diode.
-
-   - Changed the default paths for calibrated data and image files.
-     (The implemented access to these files doesn't yet exist)
-
-   - ganymed (MJCut and MJOptimize) now displayes the number of 
-     excess events versus size. The energy estimation is done in
-     MJSpectrum (sponde)
-
-   - added support for the runs 39942, 39944, 44834, 39941, 39943, 44833
-     in the calibration (MCalibColorSet)
-
-   - MJCalibration.MHCalibrationChargeCam.ProbLimit has been set to
-     1e-18 in callisto_Dec04_Jan05.rc
-
-   - ProcessFile has been renamed to Process in all job classes, because
-     ProcessFile is missleading
-
-   - support for MRunIter has been removed from the job classes (use
-     the setter functions of MSeqeunce instead)
-
-   - MEventRateCalc handles the calculation of the event rate more
-     accurate now in case of the start of a new run inside a sequence
-
-   - ganymed got support for using other variables than Alpha, eg. Theta.
-     Therefor you need a class deriving from MHAlpha which supports
-     this variable (one is already existing: MHTheta, which is now the
-     default in ganymed). It is setup through ganymed.rc
-
-   - Improved support for printing in status display:
+   - general: added new histograms for image parameters versus size
+     (MHVsSize)
+
+   - Status Display: Improved support for printing:
      + A default can now be set in .rootrc (for more details see 
        MStatusDisplay::PrintPS)
@@ -59,9 +33,9 @@
        can be canged
 
-   - improved showlog such that it handles different verbosity levels
+   - showlog: improved such that it handles different verbosity levels
      more accurate now. This mean you can suppress output when
      using showlog.
 
-   - improved showplot
+   - showplot: improved
      + The new graphics formats have been implemented 
        (pdf, svg, png, jpg and xpm)
@@ -73,18 +47,20 @@
        showplot -b --null --print --print-cmd="psbook %f" filename.root > book.ps
 
-   - The storage of the palette in MHCamera is now possible
-
-   - new bits describing unsuitable and unreliable pixels have been
-     introduced in MBadPixelsPix: kPreviouslyExcluded, kDeadPedestalRms,
-     kFluctuatingArrivalTimes
-
-   - the charge timit in the calibration has been raised from 2.5 to 4.5
-
-   - fixed reading of CC-REPORTS (weather data) for Arehucas file versions
-     newer than V200404070 
-
-   - a bug in MSrcPosCalc has been fixed (The changes were taken from
-     a bugfix of Wolfgang to Loc0LocToCam; Wolfgang: the results are
-     changed only minimally
+   - callisto: fixed a bug in the recognition of the calibration bit
+     pattern. Concerns only intensity calibration. (The strength of the 
+     intensity has been updated in some cases)
+
+   - callisto: add a filter against PIN Diode events when running over
+     calibration runs since some of the recent calibration runs have
+     been taken with Pin Diode.
+
+   - callisto: added support for the runs 39942, 39944, 44834, 39941,
+     39943, 44833 in the calibration (MCalibColorSet)
+
+   - callisto: MJCalibration.MHCalibrationChargeCam.ProbLimit has
+     been set to 1e-18 in callisto_Dec04_Jan05.rc
+
+   - callisto: the charge limit in the calibration has been raised 
+     from 2.5 to 4.5
 
    - callisto: new setup read from callisto.rc
@@ -116,5 +92,55 @@
      to a real profile in MHCamera broke it.
 
-   - The weather data is now displayed in star
+   - callisto: The cosmics filter is used in MJCalibration now 
+     independant of the pulser color (formaly it was used only for 
+     CT1-pulser data). The threshold of number of max empty pixels 
+     has been raised from 2% to 5% in MJCalibration. The maximum
+     fraction of rejected event is 50% otherwise the calibration has
+     failed. The filter now ignores unsuitable pixels.
+     Setup the filter from callisto.rc using "ContCosmics"
+     (see MFCosmics::ReadEnv)
+
+   - callisto: changed default for fgOffsetFromLogain back
+     from -2.8 to -1.8 in digital filter. 
+
+   - callisto: for the common extractors 
+      + MExtractFixedWindow
+      * MExtractTimeAndChargeSlidingWindow
+      * MExtractTimeAndChargeSpline
+      * MExtractTimeAndChargeDigitalFilter
+     the hi- and lo-gain reolution is stored in fResolutionPerPheHiGain
+     and fResolutionPerPheLoGain
+
+   - callisto: Updated the hi-/lo-gain intercalibration constants
+     hilocalib_sp1.root, hilocalib_df46_mc.root, hilocalib_df4.root, 
+     hilocalib_df6.root
+
+   - star: added muon support to star. A new tab "MHMuonPar" is
+     displayed. The lower right plot is an estimate of the point spread
+     function. A reference value is displayed. To get the real PSF
+     you must compare with MC. The setup for the muon analysis
+     is done in star.rc. More informations can be found in
+     MHSingleMuon and MHCalibParCalc
+
+   - star: The weather data is now displayed in star
+
+   - star: MEventRateCalc handles the calculation of the event rate more
+     accurate now in case of the start of a new run inside a sequence
+
+   - ganymed: a bug in MSrcPosCalc has been fixed (The changes were taken
+     from a bugfix of Wolfgang to Loc0LocToCam; Wolfgang: the results are
+     changed only minimally
+
+   - ganymed: (MJCut and MJOptimize) now displayes the number of 
+     excess events versus size. The energy estimation is done in
+     MJSpectrum (sponde)
+
+   - ganymed: got support for using other variables than Alpha, eg. Theta.
+     Therefor you need a class deriving from MHAlpha which supports
+     this variable (one is already existing: MHTheta, which is now the
+     default in ganymed). It is setup through ganymed.rc
+
+   - added a full featured spectrum program (sponde) which reads
+     ganymed output and monte carlos and compiles a spectrum
 
 
@@ -167,6 +193,6 @@
 
    - changed default for fgOffsetFromLogain from -1.8 to -2.8 in digital
-     filter. This corrects only an defective extraction of the MC at low-gain
-     signals lower than 90 phes.
+     filter. This corrects only an defective extraction of the MC at 
+     low-gain signals lower than 90 phes.
 
    - fixed some slowdown in calibrating data with interleaved events from