Index: trunk/MagicSoft/Mars/datacenter/scripts/runcallisto
===================================================================
--- trunk/MagicSoft/Mars/datacenter/scripts/runcallisto	(revision 7119)
+++ trunk/MagicSoft/Mars/datacenter/scripts/runcallisto	(revision 7120)
@@ -199,5 +199,5 @@
 
   echo "run callisto..." >> $scriptlog 2>&1
-  ./callisto -b -q -f -raw --log=$outpath/callisto$no2.log --out=$outpath --config=$callistorcseq $sequfile  2>> $scriptlog > /dev/null
+  ./callisto -b -q -f -raw --log=$outpath/callisto$no2.log --html=$outpath/callisto$no2.html --out=$outpath --config=$callistorcseq $sequfile  2>> $scriptlog > /dev/null
   check1=$?
 
@@ -259,5 +259,5 @@
                 done
              fi
-             ./merpp -u --log=$merpplogpath/merppccupdate$runno.log --runfile=$runno $ccfile $calfile 2>> $scriptlog> /dev/null
+             ./merpp -u --log=$merpplogpath/merppccupdate$runno.log --html=$merpplogpath/merppccupdate$runno.html --runfile=$runno $ccfile $calfile 2>> $scriptlog> /dev/null
              check2=$?
              case $check2 in
@@ -266,5 +266,5 @@
                           continue 2 ;;
              esac
-             ./merpp -u --log=$merpplogpath/merppcacoupdate$runno.log --auto-time $cacofile $calfile 2>> $scriptlog> /dev/null
+             ./merpp -u --log=$merpplogpath/merppcacoupdate$runno.log --html=$merpplogpath/merppcacoupdate$runno.html --auto-time $cacofile $calfile 2>> $scriptlog> /dev/null
              check3=$?
              case $check3 in
Index: trunk/MagicSoft/Mars/datacenter/scripts/runganymed
===================================================================
--- trunk/MagicSoft/Mars/datacenter/scripts/runganymed	(revision 7119)
+++ trunk/MagicSoft/Mars/datacenter/scripts/runganymed	(revision 7120)
@@ -182,29 +182,45 @@
   datasetfile="/magic/datasets/$no/dataset$no2.txt"
   echo "datasetfile: "$datasetfile >> $scriptlog 2>&1
+  wobble=`grep 'WobbleMode:' $datasetfile` >> $scriptlog 2>&1 
+  wobble2=`echo $wobble | grep ^\#` >> $scriptlog 2>&1 
+  if [ "$mode2" = "" ]
+  then 
+     mode="wobble" >> $scriptlog 2>&1 
+  else
+     mode="onoff" >> $scriptlog 2>&1 
+  fi
+  ganymedrc=/magic/datacenter/setup/ganymed/ganymed_$mode
   
   echo "run ganymed..." >> $scriptlog 2>&1
-  ./ganymed -b -q -f --sum --log=$outpath/ganymed$no2.log --out=$outpath $datasetfile  2>> $scriptlog> /dev/null
+  ./ganymed -b -q -f --sum --config=$ganymedrc.rc --log=$outpath/ganymed$no2.log --html=$outpath/ganymed$no2.html --out=$outpath $datasetfile  2>> $scriptlog> /dev/null
   check1=$?
 
   case $check1 in
      0)   echo "check1=$check1 -> everthing ok " >> $scriptlog 2>&1
-          echo "-> inserting the status for ganymed for dataset $dataset into the db" >> $scriptlog 2>&1
-          setstatuslogpath=$logpath/setstatus/ganymed/$no
-          if [ ! -d $setstatuslogpath ]
-          then
-            mkdir -pv $setstatuslogpath >> $scriptlog 2>&1
-            if [ ! -d $setstatuslogpath ]
-            then 
-               echo "could not make setstatuslogpath "$setstatuslogpath >> $scriptlog 2>&1
-               continue
-            fi
-          fi
-          setstatuslog=$setstatuslogpath/setstatus-ganymed-$no2.log
-          check4=`root -q -b $macrospath/setstatus.C+\("\"$dataset\""\,"\"$table\""\,"\"$column\""\,"\"Now()\""\) | tee $setstatuslog | grep int | sed -e 's/(int)//'`
-          case $check4 in
-  	     1)   echo "check4=$check4 -> everthing ok, status has been set" >> $scriptlog 2>&1;;
-  	     *)   echo "check4=$check4 -> ERROR -> step could not be set" >> $scriptlog 2>&1;;
-          esac
-  	  ;;
+          echo "-> do ganymed a second time "  >> $scriptlog 2>&1
+          ./ganymed -b -q -f --skip-res --config=$ganymedrc-fs.rc --log=$outpath/ganymed$no2-fs.log --html=$outpath/ganymed$no2-fs.html --outf=$outpath/ganymed$no2-fs.root $datasetfile  2>> $scriptlog> /dev/null
+          check2=$?
+          
+          case $check2 in 
+             0)   echo "check2=$check2 -> everthing ok " >> $scriptlog 2>&1
+                  echo "-> inserting the status for ganymed for dataset $dataset into the db" >> $scriptlog 2>&1
+                  setstatuslogpath=$logpath/setstatus/ganymed/$no
+                  if [ ! -d $setstatuslogpath ]
+                  then
+                     mkdir -pv $setstatuslogpath >> $scriptlog 2>&1
+                     if [ ! -d $setstatuslogpath ]
+                     then 
+                        echo "could not make setstatuslogpath "$setstatuslogpath >> $scriptlog 2>&1
+                        continue
+                     fi
+                  fi
+                  setstatuslog=$setstatuslogpath/setstatus-ganymed-$no2.log
+                  check4=`root -q -b $macrospath/setstatus.C+\("\"$dataset\""\,"\"$table\""\,"\"$column\""\,"\"Now()\""\) | tee $setstatuslog | grep int | sed -e 's/(int)//'`
+                  case $check4 in
+  	             1)   echo "check4=$check4 -> everthing ok, status has been set" >> $scriptlog 2>&1;;
+       	             *)   echo "check4=$check4 -> ERROR -> step could not be set" >> $scriptlog 2>&1;;
+                  esac
+                  ;;
+             *)   echo "check2=$check2 -> ERROR -> step has to be repeated" >> $scriptlog 2>&1;;
      *)   echo "check1=$check1 -> ERROR -> step has to be repeated" >> $scriptlog 2>&1;;
   esac
Index: trunk/MagicSoft/Mars/datacenter/scripts/runstar
===================================================================
--- trunk/MagicSoft/Mars/datacenter/scripts/runstar	(revision 7119)
+++ trunk/MagicSoft/Mars/datacenter/scripts/runstar	(revision 7120)
@@ -186,5 +186,5 @@
   
   echo "run star..." >> $scriptlog 2>&1
-  ./star -b -q -f --log=$outpath/star$sequence.log --ind=$inpath --out=$outpath $sequfile  2>> $scriptlog> /dev/null
+  ./star -b -q -f --log=$outpath/star$no2.log --html=$outpath/star$no2.html --ind=$inpath --out=$outpath $sequfile  2>> $scriptlog> /dev/null
   check1=$?
 